#ifndef MSC

    /*  Non-MSC Version  */

#if (defined(M_I86CM) || defined(M_I86LM) || defined(M_I86HM))

    /*  NOTE:  These procedures should only be used for
               large data model programs (i.e., Compact, Large, Huge) */

#include <stddef.h>
#include "alloc.h"

int ReduceDefaultData ()

/*
         +---------------------------------------+
         |                                       |  
         |  This procedure reduces the default   |  
         |  data segment to it's minimum size.   |  
         |  It should be called prior to doing   |  
         |  any memory allocation through malloc |  
         |  or calloc, etc.  Normally, the MSC   |  
         |  linker allocates 0xffff bytes to     |  
         |  this segment even though only a      |  
         |  lesser amount is actually used. This |  
         |  procedure has the same effect as     |  
         |  setting the maximum paragraph size   |  
         |  to the minimum paragraph size via    |  
         |  exemod.                              |  
         |                                       |  
         +---------------------------------------+
*/

{
   extern size_t   _abrktb [] ;
   extern size_t   _asizds    ;
   extern size_t   _psp       ;
   size_t   maxsize           ;
   size_t   newsize           ;
   size_t   para              ;
   size_t   error             ;

   newsize = NALLOC * ((_abrktb [0] - 1)/NALLOC + 1) ;
   para    = newsize / NALLOC + _abrktb [1] - _psp  ; 
   error   = _dos_setblock ( para, _psp, &maxsize ) ;
   if ( error != 0 )
      return ( FALSE ) ;

   _asizds = newsize  ;
   return ( TRUE ) ;
}

void near *_nmalloc ( nbytes )

   size_t       nbytes ;

/*
         +---------------------------------------+
         |                                       |  
         |  Dummy for _nmalloc using large data  |  
         |                                       |  
         +---------------------------------------+
*/

{
   return ( (void near *) NULL ) ;
}

void _nfree ( ap )

   void near *ap  ;

/*
         +---------------------------------------+
         |                                       |  
         |  Dummy for _nfree  (large data)       |  
         |                                       |  
         +---------------------------------------+
*/

{
}
#endif
#endif
